define(["dojo/_base/declare","dojo/_base/array","dojo/_base/lang","dojo/on","dojo/when","dojo/dom-class","dojo/promise/all","dijit/_Widget","dijit/_TemplatedMixin","dijit/_WidgetsInTemplateMixin","dijit/focus","epi/shell/dnd/Target","epi/shell/DialogService","epi/shell/widget/_ValueRequiredMixin","adaptiveimages/widget/editors/imagedetails/ImageDetailsEditor","adaptiveimages/_LogMixin","adaptiveimages/AdaptiveImagesStore","adaptiveimages/helpers/ContentHelper","adaptiveimages/widget/dialog/AlternateTextDialog","adaptiveimages/widget/editors/mixins/_DropImageFileMixin","adaptiveimages/widget/editors/mixins/_CollectionItemEditorMixin","dojo/i18n!./nls/Labels","dojo/text!./AdaptiveImageEditor.html","xstyle/css!./AdaptiveImageEditor.css"],(function(t,e,i,a,s,r,o,l,n,d,h,m,g,u,c,p,f,_,E,v,x,y,P){return t([l,n,d,u,p,v,x],{templateString:P,localized:y,debugLogName:"AdaptiveImageEditor",_target:null,_mostRecentDrop:null,_imagesReadOnly:!1,_alternateTextReadOnly:!1,_masterLanguageVersion:null,displayNames:null,validProportions:{small:null,medium:null,large:null},value:null,valueToValidate:null,missingMessage:null,required:null,constructor:function(){this.inherited(arguments)},postMixInProperties:function(){this.inherited(arguments),this._setDisplayNames(),this.missingMessage=!0===this.metadata.customEditorSettings.required_alternateText?y.validation.requiredWithAlternateText.replace("{name}",this.label):y.validation.required.replace("{name}",this.label)},_configureEditorsForMasterLanguageFallback:function(){this._masterLanguageVersion&&((this._imagesReadOnly||this.readOnly)&&(this.log("Setting applicable editor values based on master language version...",this._masterLanguageVersion),r.add(this.dropzone,"dijitReadOnly"),this.largeEditor.set("width",this._masterLanguageVersion.large.width),this.mediumEditor.set("width",this._masterLanguageVersion.medium.width),this.smallEditor.set("width",this._masterLanguageVersion.small.width),this.largeEditor.set("height",this._masterLanguageVersion.large.height),this.mediumEditor.set("height",this._masterLanguageVersion.medium.height),this.smallEditor.set("height",this._masterLanguageVersion.small.height),this.largeEditor.set("left",this._masterLanguageVersion.large.crop.left),this.mediumEditor.set("left",this._masterLanguageVersion.medium.crop.left),this.smallEditor.set("left",this._masterLanguageVersion.small.crop.left),this.largeEditor.set("right",this._masterLanguageVersion.large.crop.right),this.mediumEditor.set("right",this._masterLanguageVersion.medium.crop.right),this.smallEditor.set("right",this._masterLanguageVersion.small.crop.right),this.largeEditor.set("top",this._masterLanguageVersion.large.crop.top),this.mediumEditor.set("top",this._masterLanguageVersion.medium.crop.top),this.smallEditor.set("top",this._masterLanguageVersion.small.crop.top),this.largeEditor.set("bottom",this._masterLanguageVersion.large.crop.bottom),this.mediumEditor.set("bottom",this._masterLanguageVersion.medium.crop.bottom),this.smallEditor.set("bottom",this._masterLanguageVersion.small.crop.bottom),this._masterLanguageVersion.focalPoint&&(this.largeEditor.set("focalPointX",this._masterLanguageVersion.focalPoint.x),this.mediumEditor.set("focalPointX",this._masterLanguageVersion.focalPoint.x),this.smallEditor.set("focalPointX",this._masterLanguageVersion.focalPoint.x),this.largeEditor.set("focalPointY",this._masterLanguageVersion.focalPoint.y),this.mediumEditor.set("focalPointY",this._masterLanguageVersion.focalPoint.y),this.smallEditor.set("focalPointY",this._masterLanguageVersion.focalPoint.y)),this.largeEditor.set("filename",this._masterLanguageVersion.large.filename),this.mediumEditor.set("filename",this._masterLanguageVersion.medium.filename),this.smallEditor.set("filename",this._masterLanguageVersion.small.filename),this.largeEditor.set("provider",this._masterLanguageVersion.large.provider),this.mediumEditor.set("provider",this._masterLanguageVersion.medium.provider),this.smallEditor.set("provider",this._masterLanguageVersion.small.provider),this.largeEditor.set("imageId",this._masterLanguageVersion.large.id),this.mediumEditor.set("imageId",this._masterLanguageVersion.medium.id),this.smallEditor.set("imageId",this._masterLanguageVersion.small.id)),(this._alternateTextReadOnly||this.readOnly)&&(this.log("Using alternate text from master language"),this.largeEditor.set("alternateText",this._masterLanguageVersion.large.description),this.mediumEditor.set("alternateText",this._masterLanguageVersion.medium.description),this.smallEditor.set("alternateText",this._masterLanguageVersion.small.description)))},startup:function(){this.inherited(arguments),this.get("value")||this._setValueToCurrentCollectionItem()},postCreate:function(){this.inherited(arguments),this.log(`Setting up adaptive image property '${this.metadata.displayName||this.metadata.name}'...`,this);var t=this.metadata.customEditorSettings.master_language_value;t&&(this._masterLanguageVersion=JSON.parse(t),this.log("Parsed master language version value",this._masterLanguageVersion)),this.readOnly?(this.log("Property is in read-only state"),this.smallEditor.set("readOnly",!0),this.mediumEditor.set("readOnly",!0),this.largeEditor.set("readOnly",!0)):(this._setEditorPartialReadOnlyState(),this._alternateTextReadOnly||(this.log("Wiring up events for alternate text editing..."),this.own(a(this.altTextButton,"click",this._altTextButtonClick.bind(this)))),this._imagesReadOnly||(this.log("Wiring up events for setting/editing images..."),this._target=new m(this.dropzone,{accept:["adaptiveimage","link"],createItemOnDrop:!1}),this.own(a(this._target,"DropData",this._onDrop.bind(this))),this.own(a(this.clearButton,"click",this._clearButtonClick.bind(this))),this.smallEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.mediumEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.largeEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.smallEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this),this.mediumEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this),this.largeEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this))),this._configureEditorsForMasterLanguageFallback(),this.onUploadComplete=function(t){t&&this._onDrop({data:t,type:["link"]})},e.forEach(["small","medium","large"],function(t){this.validProportions[t]=this.metadata.customEditorSettings[`valid_proportions_${t}`];const e=this[`${t}Editor`];e.set("validProportions",this.validProportions[t]),e.set("minimumSize",{width:this.metadata.customEditorSettings[`minimum_width_${t}`]||0,height:this.metadata.customEditorSettings[`minimum_height_${t}`]||0})}.bind(this)),this.log(`Valid proportions configured for adaptive image '${this.metadata.name}'`,this.validProportions)},onChange:function(t){this.inherited(arguments)},isValid:function(t){if(!this.required)return!0;let a=this.valueToValidate,s=!0;const o=this.metadata.customEditorSettings.required_formFactors;this.log(`Validating required image property '${this.metadata.displayName}'...`,{value:a,requiredFormFactors:o}),e.forEach(o,i.hitch(this,(function(t,e){const i=this[`${t}Editor`];a[t].id&&a[t].provider?r.remove(i.domNode,"adaptiveimages-details-editor--error"):(this.logWarn(`The '${t}' form factor is required for the '${this.metadata.displayName}' property`,{value:a[t],editor:i}),r.add(i.domNode,"adaptiveimages-details-editor--error"),s=!1)})));const l=!0===this.metadata.customEditorSettings.required_alternateText;return s&&l&&!a.large.alternateText?(s=!1,r.add(this.domNode,"adaptiveimages-details-editor--error-alt-text")):r.remove(this.domNode,"adaptiveimages-details-editor--error-alt-text"),s?this.set("state",""):(this.logWarn(`The '${this.metadata.displayName||this.metadata.name}' property is required`,{requiredFormFactors:o,alternateTextRequired:l,value:this.get("value"),metadata:this.metadata}),this.set("state","Error")),s||this.log("Property value is invalid",a),s},_setValueToCurrentCollectionItem:function(){const t=this.getCurrentCollectionEditorItem();t&&(this.log("Inheriting value from current collection item...",t),this.set("value",t))},_setEditorPartialReadOnlyState:function(){!0===this.metadata.customEditorSettings.readonly_images&&(this._imagesReadOnly=!0,this.log("Images configured to be read-only"),this.smallEditor.set("readOnly",!0),this.mediumEditor.set("readOnly",!0),this.largeEditor.set("readOnly",!0),r.add(this.clearButton,"dijitReadOnly"),r.remove(this.clearButton,"hand-cursor")),!0===this.metadata.customEditorSettings.readonly_alternateText&&(this._alternateTextReadOnly=!0,this.log("Alternate text configured to be read-only"),r.add(this.altTextButton,"dijitReadOnly"),r.remove(this.altTextButton,"hand-cursor"))},_clearButtonClick:function(){this.set("value",this._createPropertyModel(!0)),this.isValid()},_getAlternateText:function(){return this.largeEditor.get("alternateText")||this.mediumEditor.get("alternateText")||this.smallEditor.get("alternateText")},_setAlternateText:function(t){if(t==this._getAlternateText())return;let e=(t||"").trim();""===e&&(e=null),this.largeEditor.set("alternateText",(e||"").trim()),this.mediumEditor.set("alternateText",e),this.smallEditor.set("alternateText",e),this.set("value",this._createPropertyModel()),this.isValid()},_altTextButtonClick:function(){let t;this.own(t=new E({model:{text:this._getAlternateText()},onOkAction:i.hitch(this,(function(t){this._setAlternateText(t.text),this.log("Alternate text updated",{newText:t.text})}))})),t.show()},_onDrop:function(t,e,i,a){this.log("Data drop",t);var r=t?t.length?t[0]:t:null;r&&s(r.data,function(t){if(r.type.includes("link")){var e=t.permanentUrl||t.permanentLink;s(_.getContentFromUrl(e),function(e){this.log("CMS image dropped for all form factors, checking dimensions...",e);let i=new f;s(i.getSettings(),function(i){t.provider=i.cmsImageProviderName,t.imageId=e.contentGuid,t.name=e.name,t.filename=_.getFilenameFromUrl(e.publicUrl),this.isValidFileType(t.filename)&&s(_.getRemoteImageDimensions(e.downloadUrl),function(e){this.log(`Dropped image is ${e.width}x${e.height} pixels`),t.width=e.width,t.height=e.height,this._handleDropData(t)}.bind(this))}.bind(this))}.bind(this))}else this.log("External image dropped for all form factors",t),t.filename||(t.filename=t.name),this._handleDropData(t)}.bind(this))},_handleDropData:function(t){if(t.imageId&&t.provider){var i=this.smallEditor.validateImageSizeAndProportions(t.width,t.height),a=this.mediumEditor.validateImageSizeAndProportions(t.width,t.height),r=this.largeEditor.validateImageSizeAndProportions(t.width,t.height);o([i,a,r]).then(function(i){this.log("Form factors validation result",i);var a=[];if(e.forEach(i,(function(t,e){t.validSize&&t.validProportions||a.push(t)})),a&&a.length>0){var r=e.map(a,(function(t,e){var i;return t.validSize||t.validProportions?t.validSize?t.validProportions||(i=y.dialogs.validationFailed.errorProportions):t.sizeConstraint.width>0&&t.sizeConstraint.height>0?i=t.imageSize.height<t.sizeConstraint.height&&t.imageSize.width<t.sizeConstraint.width?y.dialogs.validationFailed.errorSize:t.imageSize.height<t.sizeConstraint.height?y.dialogs.validationFailed.errorHeight:y.dialogs.validationFailed.errorWidth:t.sizeConstraint.width>0?i=y.dialogs.validationFailed.errorWidth:t.sizeConstraint.height>0&&(i=y.dialogs.validationFailed.errorHeight):i=t.sizeConstraint.width>0&&t.sizeConstraint.height>0?y.dialogs.validationFailed.errorSizeAndProportions:t.sizeConstraint.width>0?y.dialogs.validationFailed.errorWidthAndProportions:y.dialogs.validationFailed.errorHeightAndProportions,i.replace("{formFactor}",t.displayName).replace("{width}",t.sizeConstraint.width).replace("{height}",t.sizeConstraint.height).replace("{size}",`${t.sizeConstraint.width}x${t.sizeConstraint.height}`).replace("{x}",t.proportionsConstraint.x).replace("{y}",t.proportionsConstraint.y)})),o=a[0].imageSize,l=y.dialogs.validationFailed.title.replace("{size}",`${o.width}x${o.height}`);g.alertWithErrors({title:"Titel",heading:l},r)}else s(g.confirmation({title:y.dialogs.replaceAll.title,description:y.dialogs.replaceAll.content}),function(){this._mostRecentDrop=t,this._replaceForAll()}.bind(this))}.bind(this))}else this.logWarn("Unexpected drop",t)},_replaceForAll:function(){this.log("Replacing image for all form factors...",this._mostRecentDrop.imageId);var t={left:null,right:null,top:null,bottom:null,focalPointX:null,focalPointY:null,id:this._mostRecentDrop.imageId?this._mostRecentDrop.imageId.toString():"",provider:this._mostRecentDrop.provider,filename:this._mostRecentDrop.filename,width:this._mostRecentDrop.width,height:this._mostRecentDrop.height,alternateText:this._getAlternateText()};this.set("value",{small:t,medium:t,large:t}),this.isValid()},_setValueAttr:function(t){this.log(`Setting property value for '${this.name||this.metadata.name}'`,t),this.valueToValidate=t,h.curNode!=this.clearButton?h.focus(this.clearButton):this.onFocus(),this._set("value",t),this._refreshEditors(t),this.onChange(t)},_formFactorSpecificImageSet:function(t,e,i){this.log(`Image for form factor '${i}' set`,e),this[`${i}Editor`].set("alternateText",this._getAlternateText()),this.set("value",this._createPropertyModel()),this.isValid()},_formFactorSpecificImageCropped:function(t,e){this.log(`Image for form factor '${e}' was cropped`,t),this.set("value",this._createPropertyModel())},_refreshEditors:function(t){null===t?(this.log("No property value, assigning empty instance"),t=this._createPropertyModel(!0)):t.small||t.medium||t.large||(t=i.mixin(this._createPropertyModel(!0),t.constraints)),this.log("Refreshing editors",t),this._configureEditorsForMasterLanguageFallback(),this._alternateTextReadOnly||(this.smallEditor.set("alternateText",t.small.alternateText),this.mediumEditor.set("alternateText",t.medium.alternateText),this.largeEditor.set("alternateText",t.large.alternateText)),this._imagesReadOnly||(this.smallEditor.set("width",t.small.width),this.mediumEditor.set("width",t.medium.width),this.largeEditor.set("width",t.large.width),this.smallEditor.set("height",t.small.height),this.mediumEditor.set("height",t.medium.height),this.largeEditor.set("height",t.large.height),this.smallEditor.set("left",t.small.left),this.mediumEditor.set("left",t.medium.left),this.largeEditor.set("left",t.large.left),this.smallEditor.set("right",t.small.right),this.mediumEditor.set("right",t.medium.right),this.largeEditor.set("right",t.large.right),this.smallEditor.set("top",t.small.top),this.mediumEditor.set("top",t.medium.top),this.largeEditor.set("top",t.large.top),this.smallEditor.set("bottom",t.small.bottom),this.mediumEditor.set("bottom",t.medium.bottom),this.largeEditor.set("bottom",t.large.bottom),this.smallEditor.set("focalPointX",t.small.focalPointX),this.mediumEditor.set("focalPointX",t.medium.focalPointX),this.largeEditor.set("focalPointX",t.large.focalPointX),this.smallEditor.set("focalPointY",t.small.focalPointY),this.mediumEditor.set("focalPointY",t.medium.focalPointY),this.largeEditor.set("focalPointY",t.large.focalPointY),this.smallEditor.set("provider",t.small.provider),this.mediumEditor.set("provider",t.medium.provider),this.largeEditor.set("provider",t.large.provider),this.smallEditor.set("filename",t.small.filename),this.mediumEditor.set("filename",t.medium.filename),this.largeEditor.set("filename",t.large.filename),this.smallEditor.set("imageId",t.small.id),this.mediumEditor.set("imageId",t.medium.id),this.largeEditor.set("imageId",t.large.id));this._getAlternateText()?r.add(this.altTextButton,"epi-icon--active"):r.remove(this.altTextButton,"epi-icon--active")},_createPropertyModel:function(t){if(t)return{small:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null,focalPointX:null,focalPointY:null},medium:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null,focalPointX:null,focalPointY:null},large:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null,focalPointX:null,focalPointY:null}};var i=["provider","filename","left","right","top","bottom","focalPointX","focalPointY","width","height","alternateText"],a={};return e.forEach(["small","medium","large"],function(t){var s={};const r=`${t}Editor`;var o=this[r];o?(e.forEach(i,function(t){this._alternateTextReadOnly&&"alternateText"===t&&(s[t]=null),this._imagesReadOnly&&"alternateText"!==t&&(s[t]=null);let e=o.get(t);void 0===e&&(e=null),s[t]=e}.bind(this)),s.id=o.get("imageId"),a[t]=s):this.logError(`There is no '${r}' editor`)}.bind(this)),this.log("Property model",a),a},_setDisplayNames:function(){const t=this.metadata.customEditorSettings.display_name_large||"",e=this.metadata.customEditorSettings.display_name_medium||"",i=this.metadata.customEditorSettings.display_name_small||"";this.displayNames={large:t.replace(/'/g,'"'),medium:e.replace(/'/g,'"'),small:i.replace(/'/g,'"')},this.log("Display names set",this.displayNames)}})}));