define(["dojo/_base/declare","dojo/_base/lang","dojo/_base/array","dojo/on","dojo/mouse","dojo/ready","dojo/when","dojo/dom-style","dojo/dom-class","dojo/Deferred","dijit/_WidgetBase","dijit/_TemplatedMixin","dijit/_WidgetsInTemplateMixin","epi/shell/dnd/Target","epi/shell/widget/dialog/Alert","epi-cms/contentediting/_ContextualContentContextMixin","adaptiveimages/_LogMixin","adaptiveimages/AdaptiveImagesStore","adaptiveimages/helpers/ContentHelper","adaptiveimages/helpers/Formatter","adaptiveimages/widget/dialog/CropDialog","adaptiveimages/widget/editors/mixins/_DropImageFileMixin","adaptiveimages/widget/editors/mixins/_ThumbnailUrlResolverMixin","dojo/i18n!./nls/Labels","dojo/text!./ImageDetailsEditor.html","xstyle/css!./ImageDetailsEditor.css"],(function(i,t,e,o,n,s,a,r,h,l,d,m,g,p,u,c,f,v,z,S,w,b,P,I,_){return i([d,m,g,f,b,P],{debugLogName:"ImageDetailsEditor",templateString:_,name:null,displayName:null,imageId:null,localized:I,validProportions:null,minimumSize:null,loader:null,readOnly:!1,provider:null,filename:null,left:null,right:null,top:null,bottom:null,width:null,height:null,alternateText:null,_dialogService:null,_adaptiveImagesStore:null,constructor:function(){this.inherited(arguments),this._adaptiveImagesStore=new v},_setImageIdAttr:function(i){this._set("imageId",i),i?h.add(this.domNode,"adaptiveimages-details-editor--hasimage"):h.remove(this.domNode,"adaptiveimages-details-editor--hasimage"),null!==this.validProportions?this._setThumbnail():this.log("Valid proportions not yet known, unable to set thumbnail")},_setProviderAttr:function(i){if(i&&"string"!=typeof i)throw"Adaptive image provider name must be a string if specified";this._set("provider",i)},_setValidProportionsAttr:function(i){if(i.constructor!==Array){const t="Proportions must be an array";throw this.logError(t,{proportions:i}),t}this._set("validProportions",i),this.get("imageId")&&(this.log("Proportions updated, refreshing thumbnail..."),this._setThumbnail())},_openCropDialog:function(i){if(this.imageId){var t,e={left:this.get("left"),right:this.get("right"),top:this.get("top"),bottom:this.get("bottom"),focalPointX:this.get("focalPointX"),focalPointY:this.get("focalPointY")};this.log("Opening crop dialog...",{model:e}),this.own(t=new w({title:`${I.dialogs.crop} ${this.displayName?this.displayName.toLowerCase():""}`.trim(),provider:this.provider,imageId:this.imageId,filename:this.filename,validProportions:this.validProportions,minimumSize:this.minimumSize,model:e,onOkAction:function(i){["left","right","top","bottom","focalPointX","focalPointY"].forEach(function(t){this.set(t,i[t])}.bind(this)),this.imageCropped(i,this.name)}.bind(this)})),t.show()}},_target:null,postCreate:function(){this.inherited(arguments),this.onUploadStart=function(){this.loader.show()}.bind(this),this.onUploadComplete=function(i){this._handleCmsImageDrop(i)}.bind(this)},postMixInProperties:function(){this.inherited(arguments)},startup:function(){if(this.inherited(arguments),!this.validProportions||!this.validProportions.length)throw"No valid proportions specified";this.readOnly?h.add(this.editorContainer,"dijitReadOnly"):(this._target=new p(this.dropzone,{accept:["adaptiveimage","link"],createItemOnDrop:!1}),this.own(o(this._target,"DropData",this._onDrop.bind(this))),this.own(o(this.cropOption,"click",this._openCropDialog.bind(this))),this.own(o(this.thumbnailImage,"click",this._openCropDialog.bind(this))),this.own(o(this.resetCropOption,"click",function(){return a(this._dialogService.confirmation({title:I.dialogs.resetCrop.title,description:I.dialogs.resetCrop.description}),function(){this.log("Resetting crop and focal point settings..."),["left","right","top","bottom","focalPointX","focalPointY"].forEach(function(i){this.set(i,null)}.bind(this)),this.imageCropped(null,this.name)}.bind(this),(function(i){}))}.bind(this))),this.own(o(this.dropzone,n.enter,function(){this._setCropResetButtonVisibility()}.bind(this))))},imageDropped:function(i,t,e){},imageCropped:function(i,t){},hasSizeConstraint:function(){return this.minimumSize&&(this.minimumSize.width>0||this.minimumSize.height>0)},hasProportionsConstraint:function(){let i=!1;return e.some(this.validProportions,(function(t){if(t.allowCropping)return i=!0,!1}))[0],this.log(i?"Proportions constraints apply":"No proportions constraints apply",{validProportions:this.validProportions}),i},validateImageSizeAndProportions:function(i,t){this.log(this.name?`Validating image of ${i}x${t} pixels for form factor '${this.name}'...`:`Validating image of ${i}x${t} pixels`);var o={name:this.name,displayName:this.displayName,imageSize:i&&t?{width:i,height:t}:null,validSize:!0,validProportions:!0,sizeConstraint:this.minimumSize,proportionsConstraint:this.validProportions[0]};if(this.hasSizeConstraint())if((o.imageSize.width<this.minimumSize.width||o.imageSize.height<this.minimumSize.height)&&(this.logWarn(`Image${this.name?" for "+this.name:""} does not fulfill size restriction: width >= ${this.minimumSize.width}, height >= ${this.minimumSize.height}`),o.validSize=!1),this.hasProportionsConstraint())if(1===this.validProportions.length){this.log("Validating image fulfills proportions constraint...",this.validProportions[0]);var n=parseInt(this.minimumSize.width/(this.validProportions[0].x/this.validProportions[0].y));o.imageSize.height<n&&(this.logWarn(`Height of ${o.imageSize.height} does not meet minimum proportionate height of ${n}`),o.sizeConstraint.height=Math.max(n,o.sizeConstraint.height),o.validProportions=!1);var s=parseInt(this.minimumSize.height*(this.validProportions[0].x/this.validProportions[0].y));o.imageSize.width<s&&(this.logWarn(`Width of ${o.imageSize.width} does not meet minimum proportionate width of ${s}`),o.sizeConstraint.width=Math.max(s,o.sizeConstraint.width),o.validProportions=!1)}else{this.log("Validating image fulfills at least one of the valid proportions...",this.validProportions);let i=e.filter(this.validProportions,function(i){if(i.isFreeForm||!i.allowCropping)return!0;var t=parseInt(this.minimumSize.width/(i.x/i.y)),e=parseInt(this.minimumSize.height*(i.x/i.y));return o.imageSize.height>=t&&o.imageSize.width>=e?(this.log(`Image is valid for '${i.x}:${i.y}' proportions while maintaining a minimum size of ${t}x${t} px`,{proportions:i,resultImageSize:o.imageSize,minimumSize:this.minimumSize,proportionateMinimumSize:{width:e,height:t}}),!0):void 0}.bind(this));if(i&&i.length){let t=!1;if(e.some(i,(function(i){if(i.isDefault)return t=!0,!1})),!t){let i="";this.minimumSize.width>0&&this.minimumSize.height>0?i=I.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minSize:this.minimumSize.width>0?i=I.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minWidthOnly:this.minimumSize.height>0?i=I.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minHeightOnly:(this.logWarn("Image validation failed despite there being no size constraints."),i=I.dialogs.wrongProportions.title),this._displaySizeValidationAlert(i)}}else o.validProportions=!1}else o.validProportions=!0;return o},validateImageSizeAndProportionsOfExternalImage:function(i,t){this.log(`Validating image with ID '${t}' from provider '${i}'...`);var e=new l(function(i){this.log("Image size check cancelled",i)}.bind(this)),o=this.hasSizeConstraint(),n=this.hasSizeConstraint();if(o||n)this._adaptiveImagesStore.getMetaData(i,t).then(function(i){var t=this.validateImageSizeAndProportions(i.width,i.height);e.resolve(t)}.bind(this));else{var s=this.validateImageSizeAndProportions();e.resolve(s)}return e},_onDrop:function(i,t,e,o){var n=i?i.length?i[0]:i:null;n&&(this.loader.show(),a(n.data,function(i){n.type.includes("adaptiveimage")&&i.imageId?this._handleExternalAdaptiveImageDrop(i):n.type.includes("link")?this._handleCmsImageDrop(i):(this.logWarn("Unexpected drop",n),this.loader.hide())}.bind(this)))},_isValidFilesize:function(i,t){var e=new l;a(this._adaptiveImagesStore.getSettings(),function(o){if(!o||!o.ui||!o.ui.maximumTransformationFilesize)return void e.resolve();const n=1024*o.ui.maximumTransformationFilesize;a(this._adaptiveImagesStore.getMetaData(i,t),function(o){o.filesize?(this.log(`Validating file size of ${S.formatBytes(o.filesize)} specified by metadata against maximum size of ${S.formatBytes(n)}...`),o.filesize<n?e.resolve():e.reject()):(this.log("Image metadata did not specify filesize, retrieving through resource request..."),a(this._adaptiveImagesStore.getImageUrl(i,t,null,null,null,!0),function(i){a(z.getRemoteImageFilesize(i),function(i){i<n?e.resolve():e.reject()}.bind(this))}.bind(this)))}.bind(this))}.bind(this));var o=new l(function(i){this.log("Filesize check cancelled",i)}.bind(this));return a(e,function(){this.log("Image filesize did not exceed maximum filesize allowed for transformations"),o.resolve()}.bind(this),function(i){this.logWarn("Image exceeded maximum filesize allowed for transformations"),new u({heading:I.dialogs.exceedingFilesize.title,description:I.dialogs.exceedingFilesize.description}).show(),o.reject()}.bind(this)),o},_handleExternalAdaptiveImageDrop:function(i){this.log("Adaptive image dropped",i),a(this._isValidFilesize(i.provider,i.imageId),function(){this.validateImageSizeAndProportionsOfExternalImage(i.provider,i.imageId).then(function(t){this.log("Validated image size and proportions",t),this._displayAlertIfDimensionsAreInvalid(t)?this.loader.hide():(this._set("imageId",i.imageId),this._set("filename",i.name),this._set("provider",i.provider),this._set("width",i.width),this._set("height",i.height),["left","right","top","bottom","focalPointX","focalPointY"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped(i.provider,i.imageId,this.name))}.bind(this))}.bind(this),function(i){this.loader.hide()}.bind(this))},_handleCmsImageDrop:function(i){this.log("Handling data as CMS image drop...",i);var t=i.permanentUrl||i.permanentLink;this.log(`Validating image: ${t}...`),a(z.getContentFromUrl(t),function(i){this.log("CMS image dropped",i);const t=z.getFilenameFromUrl(i.publicUrl);this.isValidFileType(t)?a(this._adaptiveImagesStore.getSettings(),function(e){a(this._isValidFilesize(e.cmsImageProviderName,i.contentGuid),function(){a(z.getRemoteImageDimensions(i.downloadUrl),function(o){this.log(`Dropped image is ${o.width}x${o.height} pixels`);var n=this.validateImageSizeAndProportions(o.width,o.height);this.log("Validated image size and proportions",n),this._displayAlertIfDimensionsAreInvalid(n)?this.loader.hide():(this._set("imageId",i.contentGuid),this._set("filename",t),this._set("provider",e.cmsImageProviderName),this._set("width",o.width),this._set("height",o.height),["left","right","top","bottom","focalPointX","focalPointY"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped(e.cmsImageProviderName,i.contentGuid,this.name))}.bind(this))}.bind(this),function(i){this.loader.hide()}.bind(this))}.bind(this)):this.loader.hide()}.bind(this))},_displayAlertIfDimensionsAreInvalid:function(i){var t;if(!i.validSize)return this.minimumSize.width>0&&this.minimumSize.height>0?t=I.dialogs.imageTooSmall.description.size.replace("{size}",`${this.minimumSize.width}x${this.minimumSize.height}`):this.minimumSize.width>0?t=I.dialogs.imageTooSmall.description.width.replace("{width}",`${this.minimumSize.width}`):this.minimumSize.height>0&&(t=I.dialogs.imageTooSmall.description.height.replace("{height}",`${this.minimumSize.height}`)),new u({heading:I.dialogs.imageTooSmall.title,description:t}).show(),!0;if(!i.validProportions){let i="";return this.validProportions.length>1?this.minimumSize.width>0&&this.minimumSize.height>0?i=I.dialogs.wrongProportions.description.noneMatching.minSize:this.minimumSize.width>0?i=I.dialogs.wrongProportions.description.noneMatching.minWidthOnly:this.minimumSize.height>0?i=I.dialogs.wrongProportions.description.noneMatching.minHeightOnly:(this.logWarn("Image validation failed despite there being no size constraints."),i=I.dialogs.wrongProportions.title):i=this.minimumSize.width>0?I.dialogs.wrongProportions.description.widthConstraint:this.minimumSize.height>0?I.dialogs.wrongProportions.description.heightConstraint:I.dialogs.wrongProportions.description.default,this._displaySizeValidationAlert(i),!0}return!1},_displaySizeValidationAlert:function(i){this.loader.hide();let t=this.validProportions.length>1?e.map(this.validProportions,(i=>`${i.name} (${i.x}:${i.y})`)).join(", "):"";new u({heading:I.dialogs.wrongProportions.title,description:i.replace("{x}",this.validProportions[0].x).replace("{y}",this.validProportions[0].y).replace("{width}",this.minimumSize.width).replace("{height}",this.minimumSize.height).replace("{proportionsList}",t)}).show()},_setThumbnail:function(){var i=this.get("imageId"),e=this.get("provider");if(i&&e){if(!this.thumbnailImage)return void this.logWarn("No thumbnail node",this);let i=this.hasProportionsConstraint()?this._getDefaultProportions():null;this.log("Setting editor thumbnail...",{editor:this,proportions:i}),a(this.getThumbnailUrl(this,i),t.hitch(this,(function(i){if(!this.thumbnailImage||this.thumbnailImage.src&&this.thumbnailImage.src.endsWith(i)?this.log(`Thumbnail already set for '${this.name}', no need to refresh...`,this.thumbnailImage):(this.displayName?this.log(`Loading '${this.displayName}' thumbnail`,{url:i,formFactor:this.name}):this.log("Loading single image thumbnail",{url:i}),this.loader.show()),this.thumbnailImage){let t=new Image;t.addEventListener("load",function(){this.thumbnailImage&&this.thumbnailImage.setAttribute("src",i),this.dropzone&&h.add(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),this.loader&&this.loader.hide(),this.thumbnailImage&&r.set(this.thumbnailImage,{display:"inherit"})}.bind(this)),t.addEventListener("error",function(){this.logError("Unable to load thumbnail",i),this.loader.hide(),this._dialogService.alertWithErrors({heading:I.dialogs.imageLoadError.title},[i])}.bind(this)),t.src=i}}))),h.remove(this.cropOption,"dijitReadOnly")}else r.set(this.thumbnailImage,{display:"none"}),h.remove(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),h.add(this.cropOption,"dijitReadOnly"),this.loader.hide()},_setCropResetButtonVisibility:function(){this._hasCropSettings()||this._hasFocalPoint()?r.set(this.resetCropOption,"display","inherit"):r.set(this.resetCropOption,"display","none")},_hasCropSettings:function(){return this.get("right")>0||this.get("bottom")>0},_hasFocalPoint:function(){return null!=this.get("focalPointX")||null!=this.get("focalPointY")},_getDefaultProportions:function(){var i;return e.some(this.get("validProportions"),(function(t){if(t.isDefault)return i=t,!1})),i||this.logWarn("Unable to determine default proportions",{validProportions:this.validProportions}),i}})}));